﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=11.8
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals

	Private xui As XUI
	Public Chooser As ContentChooser			'Phone library
End Sub


Sub Globals

	Private xResizeAndCrop1 As xResizeAndCrop
	Private pnlCroppedImage As B4XView
	Private ImageDir, ImageFileName As String
End Sub


Sub Activity_Create(FirstTime As Boolean)

	Activity.LoadLayout("LayoutToolPage")
	
	xResizeAndCrop1.LoadImage(File.DirAssets, "image1.jpg")
	xResizeAndCrop1.WidthHeightRatio = "None"
	xResizeAndCrop1.CroppedView = pnlCroppedImage
	xResizeAndCrop1.CornerRadius = 0
	
	Private bmp As Bitmap
	bmp.Initialize(File.DirAssets, "image1.jpg")
	Log("bmp.Width initial = " & bmp.Width & " and bmp.Height = " & bmp.Height)
End Sub


Sub Activity_Resume

End Sub


Sub Activity_Pause (UserClosed As Boolean)

End Sub


'Private Sub Chooser_Result (Success As Boolean, Dir As String, FileName As String)
'	If True Then
'		ImageDir = Dir
'		ImageFileName = FileName
''		xResizeAndCrop1.LoadImage(ImageDir, ImageFileName)
'		xResizeAndCrop1.Image = xui.LoadBitmapResize(ImageDir, ImageFileName, 2000, 2000, True)
'	End If
'End Sub


Private Sub xResizeAndCrop1_CropFinished
	Log("Crop finished")
End Sub


Private Sub btnLoadImage_Click
	
	Chooser.Initialize("Chooser")
	Chooser.Show("image/*", "Select an image")
	
	Wait For Chooser_Result (Success As Boolean, Dir As String, FileName As String)
	If Success Then
		Dim bmp As Bitmap
		bmp.Initialize(Dir, FileName)
		xResizeAndCrop1.Image = bmp
		
		Log("bmp.Width loaded = " & bmp.Width & " and bmp.Height = " & bmp.Height)
	End If
End Sub


Private Sub btnSaveCroppedImage_Click
	
	Private Dir, FileName As String
	
	xui.SetDataFolder("xResizeAndCropDemo")
	Dir = xui.DefaultFolder
	Log(Dir)
	FileName = "image.png"
	Private Out As OutputStream
	Out = File.OpenOutput(Dir, FileName, False)
	xResizeAndCrop1.CroppedImage.WriteToStream(Out, 100, "PNG")
	Out.Close
	
'	'Resizes the croped image
''	Out = File.OpenOutput(Dir, "temp.png", False)
''	xResizeAndCrop1.CroppedImage.WriteToStream(Out, 100, "PNG")
''	Out.Close
''	Private bmpTemp As B4XBitmap
''	bmpTemp = xui.LoadBitmapResize(Dir, "temp.jpg", 100, 100, True)
''	Private Out As OutputStream
''	Out = File.OpenOutput(Dir, FileName, False)
''	bmpTemp.WriteToStream(Out, 100, "PNG")
''	Out.Close
''	File.Delete(Dir, "temp.png")

'	CallSubDelayed3(Main, "PaintImage", Dir, FileName)
	CallSubDelayed2(Main, "PaintImage", xResizeAndCrop1.CroppedImage)
	Activity.Finish
End Sub


'SetApplicationAttribute(android:largeHeap, "true") for
'java.lang.OutOfMemoryError: Failed to allocate a 23970828 byte allocation with 4190320 free bytes and 18MB until OOM
Private Sub btnRotateRight_Click
	
	xResizeAndCrop1.RotateImage(90)
End Sub


Private Sub btnRotateLeft_Click
	

	xResizeAndCrop1.RotateImage(-90)
End Sub